// Common Header File
// Must be used with the common.rul.

// Defines
#define README                  "readme.txt"
#define NOTEPAD                 "notepad.exe"
#define LICENSE                 "license.txt"
#define POST_INI				SRCDIR ^ "post.ini"
#define PRODUCT_KEY             "SOFTWARE" ^ @COMPANY_NAME ^ @PRODUCT_NAME ^ @PRODUCT_VERSION
#define UNINSTALL_KEY           "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall"
#define ECLIPSE_DIR             "eclipse"
#define ECLIPSE_LAUNCH_NAME     "eclipse.exe"
#define ECLIPSE_PRODUCT_FILE    ".eclipseproduct"
#define VERSION_NAME            "Version"
#define BUILD_NAME				"Build"
#define DEFAULT_DIR_NAME        "DefaultDir"
#define DISPLAY_ICON            "DisplayIcon"

// Globals
BOOL maintenanceMode;           // Determines if setup should be uninstalled or installed again.
STRING buildNumber;             // Holds the build number read from the post.ini file
STRING licenseSwitch;           // Read from post.ini file.  Determines if a license displays or not.
STRING basePath;                // Holds the install directory (similar to TARGETDIR)
STRING eclipsePath;             // Holds eclipse installation directory
STRING eclipseProductPath;      // Stores users input of an existing Eclipse product
BOOL eclipseProductFound;       // True/False based on ECLIPSE_PRODUCT_FILE found
STRING searchMedia;             // Used as a alternate MEDIA for virtual Component storage/access
BOOL versionBypass;             // State change variable used to bypass user input for destination location
                                // and start menu folders.  There are two states as described below:
                                // True - The install is an upgrade (newer) or a reinstall (same version).
                                // False - The install is happens for the first time or is older.

// Prototypes
prototype IniReader();
prototype ConfigureRegistry();
prototype FormatBytes(BYREF STRING, NUMBER, STRING);
prototype EditFiles (STRING, STRING, STRING, STRING, STRING);
prototype LONG ShFolder.SHGetFolderPathA ( HWND, INT, INT, LONG, POINTER);       
prototype STRING FormatPath(STRING, STRING, STRING);
prototype NUMBER RegistryVersionCheck();
prototype ChangeAddRemoveValues (STRING, STRING);
prototype SetDefaultDir();

